#include <p18f14K50.h>
#include "delays.h"
#include "i2c.h"
#include "eep.h"

#include "ConfigBits14K50.h"
#include "USB_CDC.h"

// ---------------------------------------------------------

unsigned char	USB_QUERY(void);

// ---------------------------------------------------------

#pragma	udata

const unsigned char Stroka1[]={'C','a','l','i','b','r','a','t','e','d',' '};
const unsigned char Stroka2[]={'A','u','t','o',' '};
const unsigned char Stroka3[]={'M','a','n','u','a','l',' '};

const unsigned char led[] = {1,1,0,1,1,1,1,		// 0
							 0,0,0,0,0,1,1,		// 1
							 1,1,1,0,1,1,0,		// 2
							 1,0,1,0,1,1,1,		// 3
							 0,0,1,1,0,1,1,		// 4
							 1,0,1,1,1,0,1,		// 5
							 1,1,1,1,1,0,1,		// 6
							 0,0,0,0,1,1,1,		// 7
							 1,1,1,1,1,1,1,		// 8
							 0,0,1,1,1,1,1};	// 9

unsigned char	USB_BUFF[64];
unsigned char	ByteCount;
signed char		cal;
signed char		mode;
signed int		y;

typedef union combo {
   unsigned int Int;      
   unsigned char Char[2];      
} Tcombo;

Tcombo x;


// =========================================================
// ================   =====================
// =========================================================

void low_isr(void);
void high_isr(void);
			
#pragma code high_vector=0x08
void interrupt_at_high_vector(void)
{
	_asm GOTO high_isr	_endasm
}

#pragma code low_vector=0x18
void interrupt_at_low_vector(void)
{
	_asm GOTO low_isr	_endasm
}

#pragma code /* return to the default code section */

// -----     ----------

#pragma interrupt high_isr

void high_isr (void)
{ 
	USB_CDC_INTERRUPT();
}

// -----     -----------

#pragma interruptlow low_isr

void low_isr (void)
{

}

// ==========================================================
//     
void led_set(char led_status)
{
	if(led_status==0){
		PORTC = 0b10000000;
		PORTC = 0b10001000;
	}
	if(led_status==1){
		PORTC = 0b11000000;
		PORTC = 0b11001000;
	}
}

//    
void led_load()
{
	PORTC = 0b00000000;
	PORTC = 0b00001000;	
	PORTC = 0b10000000;
}

//    
void led_data(char led_43)
{	
	led_set(1);							// 49 
	led_set(0);							// 48
	led_set(0);							// 47
	led_set(0);							// 46
	led_set(0);							// 45
	led_set(0);							// 44
	led_set(led_43);					// 43,  
	led_set(0);							// 42
	led_set(0);							// 41
	led_set(0);							// 40
	led_set(0);							// 39
	led_set(led[6+USB_BUFF[3]*7]);		// 38,  6
	led_set(0);							// 37
	led_set(led[5+USB_BUFF[3]*7]);		// 36,  5
	led_set(led[4+USB_BUFF[3]*7]);		// 35,  4
	led_set(led[3+USB_BUFF[3]*7]);		// 34,  3
	led_set(led[2+USB_BUFF[3]*7]);		// 33,  2
	led_set(led[1+USB_BUFF[3]*7]);		// 32,  1
	led_set(0);							// 31
	led_set(led[0+USB_BUFF[3]*7]);		// 30,  0
	led_set(led[6+USB_BUFF[1]*7]);		// 29,  6
	led_set(led[5+USB_BUFF[1]*7]);		// 28,  5
	led_set(led[4+USB_BUFF[1]*7]);		// 27,  4
	led_set(0);							// 26
	led_set(led[3+USB_BUFF[1]*7]);		// 25,  3
	led_set(led[2+USB_BUFF[1]*7]);		// 24,  2
	led_set(led[1+USB_BUFF[1]*7]);		// 23,  1
	led_set(led[0+USB_BUFF[1]*7]);		// 22,  0
	led_set(0);							// 21
	led_set(led[6+USB_BUFF[0]*7]);		// 20,  6
	led_set(led[5+USB_BUFF[0]*7]);		// 19,  5
	led_set(led[4+USB_BUFF[0]*7]);		// 18,  4
	led_set(led[3+USB_BUFF[0]*7]);		// 17,  3
	led_set(led[2+USB_BUFF[0]*7]);		// 16,  2
	led_set(led[1+USB_BUFF[0]*7]);		// 15,  1
	led_set(led[0+USB_BUFF[0]*7]);		// 14,  0
	led_set(0);							// 13
	led_set(1);							// 12,  1
	led_set(1);							// 11,  3
	led_set(1);							// 10,  2
	led_set(1);							// 09,  0
	led_set(0);							// 08
	led_set(0);							// 07
	led_set(0);							// 06
	led_set(0);							// 05
	led_set(0);							// 04
	led_set(0);							// 03
	led_set(0);							// 02
	led_load();
}

void read_temp()
{
		StartI2C();
			WriteI2C(0b10011110);
			WriteI2C(0x00);
		RestartI2C();
			WriteI2C(0b10011111);
			x.Char[1] = ReadI2C();
				AckI2C();
			x.Char[0] = ReadI2C();
				NotAckI2C();
		StopI2C();

		x.Int = (x.Int >> 5);
		x.Int = x.Int * 125 / 100 + cal;
		
		//  
		y = x.Int;
		USB_BUFF[0]=0;		
		while (y>=0){
			y-= 100;
			USB_BUFF[0]++;
		}

		//  
		y+= 100;
		USB_BUFF[1]=0;		
		while (y>=0){
			y-=10;
			USB_BUFF[1]++;
		}
		USB_BUFF[0] -= 1;
		USB_BUFF[1] -= 1;
		USB_BUFF[3] = (y+10);

		led_data(0);				//  
		y=10;						// 
		while(y>0){
			Delay1KTCYx(0);
			ClrWdt();
			y--;
		}
		led_data(1);				//  


		USB_BUFF[0] += (0x30);	//, , 
		USB_BUFF[1] += (0x30);	//, , 
		USB_BUFF[2] = '.';			//, 
		USB_BUFF[3] += (0x30);		//, 
		USB_BUFF[4] = ' ';			//  

		WRITE_TO_USB_CDC(& USB_BUFF[0], 5);		//   .
}

void main(void)
{
	// ------------------------------------------------------

	INTCON  = 0x00;				INTCON3 = 0x00;
	PIE1    = 0x00;				PIE2    = 0x00;
	CCP1CON = 0x00;											// .  .
	WPUA	= 0x00;				IOCA	= 0x00;
	WPUB	= 0x00;				IOCB	= 0x00;
	SLRCON	= 0x00;
	SSPCON1 = 0x00;				RCSTA 	= 0x00;				// .  .
	ADCON0  = 0x00;											// . , Default all pins to digital
	ANSEL	= 0x00;				ANSELH	= 0x00;
	TRISA   = 0xFF;				TRISC   = 0xFF;
	TRISB   = 0xFF;
	UCON    = 0x00;
								RCONbits.IPEN     = 1;		//    
	T1CONbits.T1OSCEN = 0x00;	T1CONbits.TMR1CS  = 0;

	// ------------------------------------------------------
	INTCONbits.GIEH   = 1;		INTCONbits.GIEL  =  1;		//  !!!
	// ------------------------------------------------------

	USB_CDC_OPEN();
	OpenI2C(MASTER, SLEW_ON);
	SSPADD = 0x77;
	cal = Read_b_eep(0x00);
	mode = Read_b_eep(0x01);
	TRISC = 0;
	// ----------------------------------------------------------
CONTINUE:	ClrWdt();
	// ----------------------------------------------------------

	while(USB_CDC_TX_BUSY());

	ByteCount = READ_FROM_USB_CDC(& USB_BUFF[0]);	//  - ???

	if(ByteCount){
		//   
		if(USB_BUFF[0]=='U'){						
			cal++;
		}

		//   
		if(USB_BUFF[0]=='D'){						
			cal--;
		}

		//   
		//   "Calibrated"  USB
		if(USB_BUFF[0]=='S'){						
			Write_b_eep(0x00, cal);				
			Busy_eep();
			WRITE_TO_USB_CDC(& Stroka1[0], 11);		
 		}

		//    
		if((USB_BUFF[0]=='R')&&(mode==0x01)){		
			read_temp();
 		}

		//    
		if(USB_BUFF[0]=='A'){						
			mode=0x00;
			Write_b_eep(0x01, mode);				
			Busy_eep();
			WRITE_TO_USB_CDC(& Stroka2[0], 5);		//   "Auto"  USB
 		}
		if(USB_BUFF[0]=='M'){						//    
			mode=0x01;
			Write_b_eep(0x01, mode);				
			Busy_eep();
			WRITE_TO_USB_CDC(& Stroka3[0], 7);		//   "Manual"  USB
 		}
		
	}


	//   
	//  , ,  ,  4   .
	if(mode==0x00){
		read_temp();

		//   ( 4  +    )
		y=90;
		while(y>0){
			Delay1KTCYx(0);
			ClrWdt();
			y--;
		}
	}

		
goto CONTINUE;
}
