
#include <p18cXXX.h>

//------------------------------------------------------

#define  _DEVICE_ID		0x0001	//  BCD !!!

//------------------------------------------------------

typedef struct
 {
	unsigned long	BaudRate;
	unsigned char	CharFormat;
	unsigned char	ParityType;
	unsigned char	DataBits;
	unsigned char	Change;
 } LINE_CODING;

extern
 LINE_CODING		USB_CDC_LINE_CODING;

//------------------------------------------------------

typedef struct
 {
	unsigned DTE    : 1;
	unsigned RTS    : 1;
	unsigned        : 5;
	unsigned Change : 1;
 } CONTROL_SIGNAL;

extern
 CONTROL_SIGNAL	USB_CDC_DTE_RTS;

//------------------------------------------------------

#define DETACHED_STATE		0x00
#define ATTACHED_STATE		0x01
#define POWERED_STATE		0x02
#define DEFAULT_STATE		0x04
#define ADR_PENDING_STATE	0x08
#define ADDRESS_STATE		0x10
#define CONFIGURED_STATE	0x20

extern
unsigned char	USB_CDC_STATE;

//------------------------------------------------------

#define USB_CDC_SUSPEND UCONbits.SUSPND

//------------------------------------------------------

void	USB_CDC_OPEN(void);
void	USB_CDC_CLOSE(void);
//	  ...

void	USB_CDC_INTERRUPT(void);
//	  USB_CDC_INTERRUPT()    
//	  
//	 , :
//	#define _INTERRUPT_LOW_PRIORITY
//	  , :
	#define _INTERRUPT_HIGH_PRIORITY

unsigned char	USB_CDC_RC_COUNT(void);
//	 USB_CDC_RC_COUNT()   
//	   USB (  64 !)

unsigned char	READ_FROM_USB_CDC(void * Buff);
//  READ_FROM_USB_CDC( & Buff)    
//   USB   Buff     USB
//    .    ,
//    USB ,  0.

unsigned char	USB_CDC_TX_BUSY(void);
//  USB_CDC_TX_BUSY()  0,   USB
// ,  ,      .

void	WRITE_TO_USB_CDC(void * Buff, unsigned char Count);
//  WRITE_TO_USB_CDC(& Buff, Count),  Count 
//   Buff  USB.   USB ,  
//    .  
// ,   USB   Buff  
//  Count,        
//    (USB_CDC_TX_BUSY() == 0).

//------------------------------------------------------
